; 
    .486                      ; force 32 bit code
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive
; 
;----------------------------------------------------------------------------

COMMENT #

 strmatchpattern PROC ptPattern :DWORD, ptString :DWORD

 return value
  *boolean*: eax=1 string matches the pattern
             eax=0 mismatch

 both, ptPattern and ptString hav to be null terminated.
 -----------------------------
 wildcard | char count
 -----------------------------
  '*'     = [ 0 ; +infinite ]
  '?'     = 1
 -----------------------------

 the algorithm is also able to recognize range definitions, eg. [a-z]
 to read about its potential plz hav a look at the original documentation.

 ---

 I ripped the code to make it available for compiling into
 libraries or dlls.

 of course it is pretty messed up and unfriendly for applying
 changes.
 but why bother recoding it. if anyone is interested in the
 functionality, plz hav a look at the original c source code.

 thanx to the author Florian Schintke.
 the original release info can be found below.



 m4d45m, AUG/2k6

#


COMMENT #
/*
  Copyright (C) 1996, 1997, 1998, 1999, 2000 Florian Schintke
 
  This is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free 
  Software Foundation; either version 2, or (at your option) any later 
  version. 
 
  This is distributed in the hope that it will be useful, but WITHOUT 
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
  for more details. 
 
  You should have received a copy of the GNU General Public License with 
  the c2html, java2html, pas2html or perl2html source package as the 
  file COPYING. If not, write to the Free Software Foundation, Inc., 
  59 Temple Place - Suite 330, Boston, MA 
  02111-1307, USA. 
*/

/* Documenttitle and purpose:                                       */
/*   Implementation of the UN*X wildcards in C. So they are         */
/*   available in a portable way and can be used whereever          */
/*   needed.                                                        */
/*                                                                  */
/* Version:                                                         */
/*   1.2                                                            */
/*                                                                  */
/* Test cases:                                                      */
/*   Please look into the Shellscript testwildcards.main            */
/*                                                                  */
/* Author(s):                                                       */
/*   Florian Schintke (schintke@gmx.de)                             */
/*                                                                  */
/* Tester:                                                          */
/*   Florian Schintke (schintke@gmx.de)                             */
/*                                                                  */
/* Testing state:                                                   */
/*   tested with the atac tool                                      */
/*   Latest test state is documented in testwildcards.report        */
/*   The program that tested this functions is available as         */
/*   testwildcards.c                                                */
/*                                                                  */
/* Dates:                                                           */
/*   First editing: unknown, but before 04/02/1997                  */
/*   Last Change  : 04/07/2000                                      */
/*                                                                  */
/* Known Bugs:                                                      */
/*                                                                  */
#

.code
strmatchpattern PROC ptPattern :DWORD, ptString :DWORD

 push ptString		; pass the arguments
 push ptPattern		; 
 call _10001000		; call the actual routine
 leave			; add esp, 0Ch ;could also be used
 retn 08h		; cleanup the stack after ret (the 2 args)

;i set up the above code coz
;_10001000 is called recursively by the function itself.

_10001000: ENTER 0004,00
_10001004: PUSH EBX
_10001005: PUSH ESI
_10001006: MOV DWORD PTR [EBP-04h],00000001
_1000100D: MOV EAX,[EBP+08h]
_10001010: CMP BYTE PTR [EAX],00
_10001013: JZ _1000109C
_10001019: CMP DWORD PTR [EBP-04h],01
_1000101D: JNZ _1000109C
_10001023: MOV ECX,[EBP+0Ch]
_10001026: CMP BYTE PTR [ECX],00
_10001029: JZ _1000109C
_1000102F: MOV EBX,[EBP+08h]
_10001032: MOVSX EDX,BYTE PTR [EBX]
_10001035: CMP EDX,5Bh
_10001038: JZ _10001046
_1000103A: CMP EDX,3Fh
_1000103D: JZ _1000105E
_1000103F: CMP EDX,2Ah
_10001042: JZ _10001063
_10001044: JMP _1000107B
_10001046: INC DWORD PTR [EBP+08h]
_10001049: LEA ESI,[EBP+0Ch]
_1000104C: PUSH ESI
_1000104D: LEA EAX,[EBP+08h]
_10001050: PUSH EAX
_10001051: CALL _100010D2
_10001056: MOV [EBP-04h],EAX
_10001059: ADD ESP,08
_1000105C: JMP _10001094
_1000105E: INC DWORD PTR [EBP+0Ch]
_10001061: JMP _10001094
_10001063: LEA ECX,[EBP+0Ch]
_10001066: PUSH ECX
_10001067: LEA EDX,[EBP+08h]
_1000106A: PUSH EDX
_1000106B: CALL _100011A6
_10001070: MOV [EBP-04h],EAX
_10001073: DEC DWORD PTR [EBP+08h]
_10001076: ADD ESP,08
_10001079: JMP _10001094
_1000107B: MOV EBX,[EBP+08h]
_1000107E: MOV AL,[EBX]
_10001080: MOV ESI,[EBP+0Ch]
_10001083: CMP AL,[ESI]
_10001085: MOV ECX,00000001
_1000108A: JZ _1000108E
_1000108C: XOR ECX,ECX
_1000108E: MOV [EBP-04h],ECX
_10001091: INC DWORD PTR [EBP+0Ch]
_10001094: INC DWORD PTR [EBP+08h]
_10001097: JMP _1000100D
_1000109C: MOV EDX,[EBP+08h]
_1000109F: CMP BYTE PTR [EDX],2Ah
_100010A2: JNZ _100010AF
_100010A4: CMP DWORD PTR [EBP-04h],01
_100010A8: JNZ _100010AF
_100010AA: INC DWORD PTR [EBP+08h]
_100010AD: JMP _1000109C
_100010AF: CMP DWORD PTR [EBP-04h],01
_100010B3: JNZ _100010C5
_100010B5: MOV EBX,[EBP+0Ch]
_100010B8: CMP BYTE PTR [EBX],00
_100010BB: JNZ _100010C5
_100010BD: MOV EAX,[EBP+08h]
_100010C0: CMP BYTE PTR [EAX],00
_100010C3: JZ _100010C9
_100010C5: XOR EAX,EAX
_100010C7: JMP _100010CE
_100010C9: MOV EAX,00000001
_100010CE: POP ESI
_100010CF: POP EBX
_100010D0: LEAVE
_100010D1: RETN

_100010D2: ENTER 000Ch,00
_100010D6: PUSH EBX
_100010D7: PUSH ESI
_100010D8: XOR EAX,EAX
_100010DA: MOV [EBP-0Ch],EAX
_100010DD: MOV [EBP-08h],EAX
_100010E0: MOV DWORD PTR [EBP-04h],00000001
_100010E7: MOV ECX,[EBP+08h]
_100010EA: MOV EDX,[ECX]
_100010EC: CMP BYTE PTR [EDX],21
_100010EF: JNZ _100010FE
_100010F1: MOV EBX,00000001
_100010F6: MOV [EBP-08h],EBX
_100010F9: MOV ESI,[EBP+08h]
_100010FC: INC DWORD PTR [ESI]
_100010FE: MOV EAX,[EBP+08h]
_10001101: MOV ECX,[EAX]
_10001103: CMP BYTE PTR [ECX],5D
_10001106: JNZ _10001112
_10001108: CMP DWORD PTR [EBP-04h],01
_1000110C: JNZ _10001183
_10001112: CMP DWORD PTR [EBP-0Ch],00
_10001116: JNZ _10001172
_10001118: MOV EDX,[EBP+08h]
_1000111B: MOV EBX,[EDX]
_1000111D: CMP BYTE PTR [EBX],2D
_10001120: JNZ _1000115B
_10001122: MOV AL,[EBX-01h]
_10001125: CMP AL,[EBX+01h]
_10001128: JNL _1000115B
_1000112A: CMP BYTE PTR [EBX+01h],5D
_1000112E: JZ _1000115B
_10001130: CMP DWORD PTR [EBP-04h],00
_10001134: JNZ _1000115B
_10001136: MOV ESI,[EBP+0Ch]
_10001139: MOV ECX,[ESI]
_1000113B: MOV DL,[ECX]
_1000113D: MOV EBX,[EBP+08h]
_10001140: MOV EAX,[EBX]
_10001142: CMP DL,[EAX-01h]
_10001145: JL _10001172
_10001147: CMP DL,[EAX+01h]
_1000114A: JNLE _10001172
_1000114C: MOV ESI,00000001
_10001151: MOV [EBP-0Ch],ESI
_10001154: MOV ECX,[EBP+08h]
_10001157: INC DWORD PTR [ECX]
_10001159: JMP _10001172
_1000115B: MOV EDX,[EBP+08h]
_1000115E: MOV EBX,[EDX]
_10001160: MOV AL,[EBX]
_10001162: MOV ESI,[EBP+0Ch]
_10001165: MOV ECX,[ESI]
_10001167: CMP AL,[ECX]
_10001169: JNZ _10001172
_1000116B: MOV DWORD PTR [EBP-0Ch],00000001
_10001172: MOV EDX,[EBP+08h]
_10001175: INC DWORD PTR [EDX]
_10001177: MOV DWORD PTR [EBP-04h],00000000
_1000117E: JMP _100010FE
_10001183: CMP DWORD PTR [EBP-08h],01
_10001187: JNZ _10001194
_10001189: MOV EBX,00000001
_1000118E: SUB EBX,[EBP-0Ch]
_10001191: MOV [EBP-0Ch],EBX
_10001194: CMP DWORD PTR [EBP-0Ch],01
_10001198: JNZ _1000119F
_1000119A: MOV EAX,[EBP+0Ch]
_1000119D: INC DWORD PTR [EAX]
_1000119F: MOV EAX,[EBP-0Ch]
_100011A2: POP ESI
_100011A3: POP EBX
_100011A4: LEAVE
_100011A5: RETN

_100011A6: ENTER 0004,00
_100011AA: PUSH EBX
_100011AB: PUSH ESI
_100011AC: MOV EAX,00000001
_100011B1: MOV [EBP-04h],EAX
_100011B4: MOV ECX,[EBP+08h]
_100011B7: INC DWORD PTR [ECX]
_100011B9: MOV EDX,[EBP+0Ch]
_100011BC: MOV EBX,[EDX]
_100011BE: CMP BYTE PTR [EBX],00
_100011C1: JZ _100011EA
_100011C3: MOV ESI,[EBP+08h]
_100011C6: MOV EAX,[ESI]
_100011C8: MOV CL,[EAX]
_100011CA: CMP CL,3Fh
_100011CD: JZ _100011D4
_100011CF: CMP CL,2Ah
_100011D2: JNZ _100011EA
_100011D4: MOV EDX,[EBP+08h]
_100011D7: MOV EBX,[EDX]
_100011D9: CMP BYTE PTR [EBX],3Fh
_100011DC: JNZ _100011E3
_100011DE: MOV ESI,[EBP+0Ch]
_100011E1: INC DWORD PTR [ESI]
_100011E3: MOV EAX,[EBP+08h]
_100011E6: INC DWORD PTR [EAX]
_100011E8: JMP _100011B9
_100011EA: MOV ECX,[EBP+08h]
_100011ED: MOV EDX,[ECX]
_100011EF: CMP BYTE PTR [EDX],2Ah
_100011F2: JNZ _100011FB
_100011F4: MOV EBX,[EBP+08h]
_100011F7: INC DWORD PTR [EBX]
_100011F9: JMP _100011EA
_100011FB: MOV ESI,[EBP+0Ch]
_100011FE: MOV EAX,[ESI]
_10001200: CMP BYTE PTR [EAX],00
_10001203: JNZ _10001218
_10001205: MOV ECX,[EBP+08h]
_10001208: MOV EDX,[ECX]
_1000120A: CMP BYTE PTR [EDX],00
_1000120D: JZ _10001218
_1000120F: XOR EAX,EAX
_10001211: MOV [EBP-04h],EAX
_10001214: POP ESI
_10001215: POP EBX
_10001216: LEAVE
_10001217: RETN

_10001218: MOV EBX,[EBP+0Ch]
_1000121B: MOV ESI,[EBX]
_1000121D: CMP BYTE PTR [ESI],00
_10001220: JNZ _10001238
_10001222: MOV ECX,[EBP+08h]
_10001225: MOV EDX,[ECX]
_10001227: CMP BYTE PTR [EDX],00
_1000122A: JNZ _10001238
_1000122C: MOV EAX,00000001
_10001231: MOV [EBP-04h],EAX
_10001234: POP ESI
_10001235: POP EBX
_10001236: LEAVE
_10001237: RETN

_10001238: MOV EBX,[EBP+0Ch]
_1000123B: PUSH DWORD PTR [EBX]
_1000123D: MOV ESI,[EBP+08h]
_10001240: PUSH DWORD PTR [ESI]
_10001242: CALL _10001000
_10001247: ADD ESP,08
_1000124A: TEST EAX,EAX
_1000124C: JNZ _10001299
_1000124E: MOV ECX,[EBP+0Ch]
_10001251: INC DWORD PTR [ECX]
_10001253: MOV EDX,[EBP+08h]
_10001256: MOV EAX,[EDX]
_10001258: MOV BL,[EAX]
_1000125A: MOV ESI,[EBP+0Ch]
_1000125D: MOV ECX,[ESI]
_1000125F: CMP BL,[ECX]
_10001261: JZ _10001274
_10001263: CMP BYTE PTR [EAX],5Bh
_10001266: JZ _10001274
_10001268: CMP BYTE PTR [ECX],00
_1000126B: JZ _10001274
_1000126D: MOV EDX,[EBP+0Ch]
_10001270: INC DWORD PTR [EDX]
_10001272: JMP _10001253
_10001274: MOV EAX,[EBP+0Ch]
_10001277: MOV EBX,[EAX]
_10001279: CMP BYTE PTR [EBX],00
_1000127C: JZ _10001292
_1000127E: PUSH EBX
_1000127F: MOV ESI,[EBP+08h]
_10001282: PUSH DWORD PTR [ESI]
_10001284: CALL _10001000
_10001289: ADD ESP,08
_1000128C: TEST EAX,EAX
_1000128E: JZ _1000124E
_10001290: JMP _10001299
_10001292: XOR ECX,ECX
_10001294: MOV [EBP-04h],ECX
_10001297: JNZ _1000124E
_10001299: MOV EDX,[EBP+0Ch]
_1000129C: MOV EAX,[EDX]
_1000129E: CMP BYTE PTR [EAX],00
_100012A1: JNZ _100012B4
_100012A3: MOV EBX,[EBP+08h]
_100012A6: MOV ESI,[EBX]
_100012A8: CMP BYTE PTR [ESI],00
_100012AB: JNZ _100012B4
_100012AD: MOV DWORD PTR [EBP-04h],00000001
_100012B4: MOV EAX,[EBP-04h]
_100012B7: POP ESI
_100012B8: POP EBX
_100012B9: LEAVE
_100012BA: RETN

strmatchpattern ENDP
END
